{% for upstream in site.upstreams %}
upstream {{ upstream.name }}  {
    {% for origin in upstream.origins %}
    server {{ origin }};
    {% endfor %}
}
{% endfor %}

server {
    listen [::]:80;
    server_name {{ site.server_name }};

    location / {
        return 301 https://$host$request_uri;
    }
}

server {
    listen [::]:443 ssl http2;
    server_name {{ site.server_name }};

    ssl_certificate /etc/lego/{{ site.server_name }}.crt;
    ssl_certificate_key /etc/lego/{{ site.server_name }}.key;
    ssl_trusted_certificate /etc/lego/{{ site.server_name }}root_CA_cert_plus_intermediates;
    ssl_session_timeout 1d;
    ssl_session_cache shared:MozSSL:10m;  # about 40000 sessions
    ssl_session_tickets off;
    ssl_protocols TLSv1.3;
    ssl_prefer_server_ciphers off;
    # HSTS (ngx_http_headers_module is required) (63072000 seconds)
    # add_header Strict-Transport-Security "max-age=63072000" always;
    ssl_stapling on;
    ssl_stapling_verify on;
    # verify chain of trust of OCSP response using Root CA and Intermediate certs
    ssl_trusted_certificate /etc/lego/{{ site.server_name }}root_CA_cert_plus_intermediates;
    resolver 127.0.0.1;

    {% for line in site.extra_configuration %}
    {{ line }};
    {% endfor %}

    {% for location in site.locations %}
    location {{ location.path }} {
        {% for line in location.configuration %}
        {{ line }};
        {% endfor %}
    }
    {% endfor %}
}
